-- $RCSfile: load_control.sql,v $
-- $Author: schwie $
-- $Revision: 1.10 $
-- $Date: 2007/09/06 13:16:39 $

-- Blast it all away
delete from `control`;

-- Use waiver wire system
insert into `control` (`control_key`,`control_value`,`control_desc`,`control_allowed_values`) values ('CONFIG_USE_WW','Yes','Use the waiver wire system','Yes,No');
-- Number of hours players are on waivers when they are released
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('CONFIG_WW_HOURS','48','Hours a player spends on the waiver wire after being dropped (minimum)');
-- Number of hours after trade accepted during which it can be protested / vetoed
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('CONFIG_TRADE_HOURS','24','Hours a trade may be protested by the league (minimum)');
-- Percentage of total teams (rounded up) required to overturn a trade via protest
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('CONFIG_TRADE_PROTEST_PCT','50','Percentage of teams needed to overturn a trade via protest');
-- Number of hours once a trade goes to "rosterviolation" before it is deleted
-- (prevents accepted uncompleted trades from permanently locking out players from trade)
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('CONFIG_ROSTERVIOLATION_HOURS','168','Number of hours before a trade expires if its completion would violate roster constraints');
-- when does the season actually start?
insert into `control` (`control_key`,`control_value`,`control_desc`,`all_leagues`) values ('MISC_SEASON_START_2007','2007-09-04 03:00:00','Should be set to the Tuesday or Wednesday prior to the first game.  Governs `control` of current week relative to the NFL.',1);

-- Use draft system
insert into `control` (`control_key`,`control_value`,`control_desc`,`control_allowed_values`) values
('CONFIG_USE_DRAFT','Yes','Use the draft format','Yes,No');


-- Use auction system
insert into `control` (`control_key`,`control_value`,`control_desc`,`control_allowed_values`) values
('CONFIG_USE_AUCTION','No','Use the auction format','Yes,No');
-- Salary cap is the maximum amount a team may spend at the league auction
insert into `control` (`control_key`,`control_value`,`control_desc`) values	
('CONFIG_SALARY_CAP','100','Maximum amount a team can spend at the auction');
-- Screen Refresh is the number of seconds it will take for the auction page to -- refresh.  Set the value to zero if you would prefer that it not refresh.
insert into `control` (`control_key`,`control_value`,`control_desc`) values
('CONFIG_AUCTION_SCREEN_REFRESH','0','Number of seconds between screen refreshes for auction page.');
-- This is the lowest a player can be purchased for in your auction.
insert into `control` (`control_key`,`control_value`,`control_desc`) values
('CONFIG_MIN_PER_PLAYER','1','This is the minimum dollar amount a player can be purchased for in your auction.');



-- Color scheme stuff
insert into `control` (`control_key`,`control_value`,`control_desc`,`all_leagues`) values ('STYLE_DARK_COLOR','000066','Used for some of the color scheme',1);

-- Admin/Webmaster ID
insert into `control` (`control_key`,`control_value`,`control_desc`,`all_leagues`) values ('MISC_WEBMASTER_EMAIL','offladmin@localhost','Email link to the webmaster provided in the footer',1);

-- Team `control`
-- Some sort of controlled flex position is needed, I think
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('CONFIG_MAX_START_QB','1','Maximum allowed starting quarterbacks');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('CONFIG_MAX_START_RB','1','Maximum allowed starting running backs');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('CONFIG_MAX_START_WR','1','Maximum allowed starting wide receivers');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('CONFIG_MAX_START_TE','1','Maximum allowed starting tight ends');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('CONFIG_MAX_START_K','1','Maximum allowed starting kickers');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('CONFIG_MAX_START_DEF','1','Maximum allowed starting team defenses');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('CONFIG_MAX_START_RB_WR_FLEX','1','Maximum allowed starting flex positions for RBs or WRs');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('CONFIG_MAX_START_WR_TE_FLEX','1','Maximum allowed starting flex positions for WRs or TEs');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('CONFIG_MAX_START_PLAYERS','8','Maximum starting players.  Does not necessarily have to equal the sum of the individual position max starters.');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('CONFIG_MAX_TOTAL_QB','3','Maximum quarterbacks (starting and bench) on roster');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('CONFIG_MAX_TOTAL_RB','5','Maximum running backs (starting and bench) on roster');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('CONFIG_MAX_TOTAL_WR','6','Maximum wide receivers (starting and bench) on roster');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('CONFIG_MAX_TOTAL_TE','3','Maximum tight ends (starting and bench) on roster');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('CONFIG_MAX_TOTAL_K','3','Maximum kickers (starting and bench) on roster');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('CONFIG_MAX_TOTAL_DEF','3','Maximum team defenses (starting and bench) on roster');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('CONFIG_MAX_TOTAL_PLAYERS','14','Maximum total roster size (starters and bench).  Probably should not equal the sum of the individual position roster maximums');

-- Scoring `control` 
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_PASS_ATT','0','Points awarded per pass attempt');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_PASS_CMP','0','Points awarded per pass completion');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_PASS_YD','0.034','Points awarded per passing yard');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_PASS_TD','6','Points awarded per passing touchdown');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_PASS_300YD','3','Bonus points awarded for reaching 300 yds passing');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_RUSH_ATT','0','Points awarded per rushing attempt');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_RUSH_YD','0.067','Points awarded per rushing yard');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_RUSH_TD','6','Points awarded per rushing touchdown');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_RUSH_100YD','3','Bonus points awarded for reaching 100 yds rushing');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_REC_ATT','1','Points awarded per reception');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_REC_YD','0.067','Points awarded per receiving yard');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_REC_TD','6','Points awarded per receiving touchdown');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_REC_100YD','3','Bonus points awarded for reaching 100 yds receiving');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_KRET_ATT','0','Points awarded per kickoff return');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_KRET_YD','0','Points awarded per kickoff return yard');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_KRET_TD','0','Points awarded per kickoff return touchdown');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_PRET_ATT','0','Points awarded per punt return');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_PRET_YD','0','Points awarded per punt return yard');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_PRET_TD','0','Points awarded per punt return touchdown');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_INT','-2','Points awarded per interception thrown');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_FMBL_LOST','-2','Points awarded per fumble lost');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_TWOPT','2','Points awarded per two-point conversion completed (run, pass, or catch)');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_FG_0_19','3','Points awarded per field goal, 0-19 yards');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_FG_20_29','3','Points awarded per field goal, 20-29 yards');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_FG_30_39','3','Points awarded per field goal, 30-39 yards');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_FG_40_49','4','Points awarded per field goal, 40-49 yards');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_FG_50P','5','Points awarded per field goal, 50+ yards');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_FG_MISSED','0','Points awarded per field goal missed');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_XP','1','Points awarded per extra point (PAT)');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_XP_MISSED','-1','Points awarded per extra point missed');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_DEF_PT_LIMIT_1','0','First-level defensive points allowed limit');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_DEF_PT_1','10','Points awarded if defense allows level 1 points or fewer');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_DEF_PT_LIMIT_2','6','Second-level defensive points allowed');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_DEF_PT_2','7','Points awarded if defense allows more points than level 1 but equal to or fewer than level 2');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_DEF_PT_LIMIT_3','13','3rd level point limit');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_DEF_PT_3','4','3rd level point award');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_DEF_PT_LIMIT_4','20','4th etc');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_DEF_PT_4','1','4th etc');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_DEF_PT_LIMIT_5','27','etc');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_DEF_PT_5','0','etc');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_DEF_PT_LIMIT_6','34','etc');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_DEF_PT_6','-1','etc');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_DEF_PT_LIMIT_7','2000','etc');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_DEF_PT_7','-4','etc');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_DEF_PT_LIMIT_8','2000','Default worst-case points allowed limit.  Should be a ridiculously high value');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_DEF_PT_8','-4','Default worst-case points allowed scoring value');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_DEF_YD_LIMIT_1','0','First-level defensive yards allowed limit');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_DEF_YD_1','10','Points awarded if defense allows level 1 yards or fewer');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_DEF_YD_LIMIT_2','50','Second-level defensive yards allowed limit');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_DEF_YD_2','9','Points awarded if defense allows more yards than level 1 but equal to or fewer than level 2');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_DEF_YD_LIMIT_3','100','3rd level yard limit');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_DEF_YD_3','8','3rd level point award');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_DEF_YD_LIMIT_4','150','4th etc');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_DEF_YD_4','7','4th etc');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_DEF_YD_LIMIT_5','200','etc');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_DEF_YD_5','6','etc');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_DEF_YD_LIMIT_6','250','etc');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_DEF_YD_6','4','etc');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_DEF_YD_LIMIT_7','300','etc');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_DEF_YD_7','2','etc');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_DEF_YD_LIMIT_8','2000','Default worst-case yards allowed limit.  Should be a ridiculously high value');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_DEF_YD_8','0','Default worst-case yards allowed scoring value');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_DEF_SACK','1','Points awarded per defensive sack');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_DEF_FMBL_REC','2','Points awarded per defensive fumble recovery');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_DEF_INT','2','Points awarded per defensive interception');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_DEF_FMBL_TD','6','Points awarded per defensive fumble returned for a touchdown');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_DEF_INT_TD','6','Points awarded per defensive interception returned for a touchdown');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_DEF_RET_TD','6','Points awarded to a defensive unit for a kick or punt returned for a touchdown');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_DEF_MISC_TD','6','Points awarded to a defensive unit for other touchdowns scores (blocked punts or the like)');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_DEF_SAFETY','2','Points awarded per defensive safety');
insert into `control` (`control_key`,`control_value`,`control_desc`) values ('SCORING_DEF_BLK_KICK','2','Points awarded per defensive blocked kick (FG, XP, or punt)');

-- use fractional points? 'Yes'/'No'
insert into `control` (`control_key`,`control_value`,`control_desc`,`control_allowed_values`) values ('SCORING_FRAC_POINTS','No','Fractional points awarded (else rounded down)','Yes,No');
-- use negative points? 'Yes'/'No'
insert into `control` (`control_key`,`control_value`,`control_desc`,`control_allowed_values`) values ('SCORING_NEG_POINTS','Yes','Negative points awarded for negative yardage','Yes,No');

-- Lead Pipe Lock minigame config
insert into `control` (`control_key`,`control_value`,`control_desc`,`control_allowed_values`)
    values ('MISC_LPL_ENABLE','No','Enable the Lead Pipe Lock pick-em minigame','Yes,No');
insert into `control` (`control_key`,`control_value`,`control_desc`,`control_allowed_values`)
    values ('MISC_LPL_ELIMINATION','Elimination','Set the Lead Pipe Lock pick-em minigame to single-fail elimination or season-long total','Elimination,Season Total');
