
drop table if exists `playerstats`;
create table `playerstats` (
	`stat_id`		int unsigned not null auto_increment,
	`player_id`		smallint unsigned,
	`year`			smallint unsigned,
	`week`			tinyint unsigned,
	`nflteam_id`	tinyint unsigned,
	`pass_att`		int DEFAULT 0, # passing
	`pass_cmp`		int DEFAULT 0,
	`pass_yd`		int DEFAULT 0,
	`pass_td`		int DEFAULT 0,
	`rush_att`		int DEFAULT 0, # rushing
	`rush_yd`		int DEFAULT 0,
	`rush_td`		int DEFAULT 0,
	`rec_att`		int DEFAULT 0, # receiving
	`rec_yd`		int DEFAULT 0,
	`rec_td`		int DEFAULT 0,
	`kret_att`		int DEFAULT 0, # kick returns (individ. players)
	`kret_yd`		int DEFAULT 0,
	`kret_td`		int DEFAULT 0,
	`pret_att`		int DEFAULT 0, # punt returns (individ. players)
	`pret_yd`		int DEFAULT 0,
	`pret_td`		int DEFAULT 0,
	`int`			int DEFAULT 0, # special cases
	`fmbl_lost`		int DEFAULT 0,
	`twopt`			int DEFAULT 0,
	`fg_0_19`		int DEFAULT 0, #field goals
	`fg_20_29`		int DEFAULT 0,
	`fg_30_39`		int DEFAULT 0,
	`fg_40_49`		int DEFAULT 0,
	`fg_50p`		int DEFAULT 0,
	`fga`			int DEFAULT 0,
	`xp`			int DEFAULT 0, # extra points
	`xpa`			int DEFAULT 0,
	`def_pt`		int DEFAULT NULL, # defense - points allowed
	`def_yd`		int DEFAULT NULL, # yards allowed
	`def_pyd`		int DEFAULT NULL, # pass yards allowed
	`def_ryd`		int DEFAULT NULL, # rush yards allowed
	`def_sack`		int DEFAULT 0, # defense special cases
	`def_fmbl_rec`	int DEFAULT 0,
	`def_int`		int DEFAULT 0,
	`def_fmbl_td`	int DEFAULT 0,
	`def_int_td`	int DEFAULT 0,
	`def_ret_td`	int DEFAULT 0, # punt/kick returns (team)
	`def_misc_td`	int DEFAULT 0, # anything else resulting in a TD
	`def_safety`	int DEFAULT 0,
	`def_blk_kick`	int DEFAULT 0, # XP / FG / Punt catch-all
	primary key (`stat_id`)
);
