<?php
/**
 * Upgrade script for OFFL 0.2.3 (run on 0.2.x)
 *
 * This patch upgrades an OFFL 0.2.x install to OFFL 0.2.3.  Notable changes include additional
 * game fields for description and playoff status.
 *
 * @author Stephen Rochelle <lomn@lomn.net>
 * @version OFFL v0.2
 * @copyright Copyright (c) 2004 Stephen Rochelle.  Some rights reserved.
 * @package offl-ui
 */

$pageTitle = "";
require_once("offlconfig.php");
require_once($DOC_ROOT . "/lib/classes/offl_dbobject.php"); // gets database object for upgrading the DB.

$fix = new OFFL_DBObject();

$fix->SQLQuery("INSERT INTO `control` ( `control_key` , `control_value` , `control_desc` , `control_allowed_values` , `league_id` , `all_leagues` ) VALUES ('MISC_SEASON_START_2005', '2005-09-07 00:00:00', 'Should be set to the Tuesday or Wednesday prior to the first game. Governs `control` of current week relative to the NFL.', NULL , '0', '1')");

echo "<p>2005 season date configured successfully.  You may now delete this file.</p>";

exit();
?>